

#include "main.h"
#define baudrate 4800
#define cpuclock 16000000
#define SYSCLK	16000000
#define BAUD_RATE 4800
//FUNKTIONEN
void waitms(unsigned short int ms);
unsigned char read_SPI(void);
unsigned char Write_SPI(char data);
int uart_putchar (char c);
void DelayUs(unsigned int N);




// RS232 INIT UART0
void init_rs232(unsigned int baud0,unsigned int baud1)
{

UCSR0B= ((1<<RXCIE0)|(1<<RXEN0) | (1<<TXEN0));
UBRR0L=(SYSCLK / (BAUD_RATE * 16L) - 1);


  }
  

 //zum Senden ber die UART 1
void send_UART(char *s)
{
uint8_t cz=0;
 while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
if(cz>40)break;    
  loop_until_bit_is_set(UCSR0A, UDRE0);
 UDR0=(*s);
        s++;
		cz++;
    }
}


//SETZTE PORTS
void set_ports(void)
{
port_spi_osd_cs(); //CS OSD
port_spi_sck(); //SCK
port_spi_mosi();//MOSI
port_spi_miso();//MISO
port_spi_ss();//SS MASTER MODE


osd_cs_high();//CS High
ss_high();//SS High Master Mode

led1_port();
led2_port();
led3_port();


led1_low();
led2_low();
led3_low();

video_loss();
taster_set();
taster_set_pullup();
taster_move();
taster_move_pullup();
max_reset();	

}





int main(void)
{
waitms(2000);
set_ports();
//RESET OSD
maxreset_low();
waitms(60);
maxreset_high();

int baud;
baud=cpuclock/((baudrate*16L)-1);
cli();
init_rs232(baud,baud);
sei();
waitms(500);
send_UART("----------------------\r\n");
send_UART("--   OSD-TERMINAL   --\r\n");
send_UART("----------------------\r\n");
send_UART("\r\n");
send_UART("System Test!\r\n");
send_UART("\r\n");
send_UART("Check LED1\r\n");
waitms(1000);
led1_high();
waitms(4000);
send_UART("Check LED2\r\n");
waitms(1000);
led2_high();
waitms(4000);
send_UART("Check LED3\r\n");
waitms(1000);
led3_high();
waitms(8000);
led1_low();
led2_low();
led3_low();
send_UART("SET POWER LED ON LED1\r\n");
waitms(1000);
led1_high();
waitms(1000);
send_UART("SET OSD ON/OFF LED ON LED2\r\n");
waitms(1000);
send_UART("SET VIDEO_LOSS LED ON LED3\r\n");
set_vm0();
set_vm1();

//ABRUFEN STATUS
sprintf(buffer,"Status: %x\r\n",read_status_osd());
send_UART(&buffer[0]);


while(1)
{

//PRFE VIDEO LOSS
if ( PINB & (1<<PINB1) ) 
{
led3_high();//VIDEO SIGNAL VERLOREN
}
else
{
led3_low();//VIDEO SIGNAL IST OK
}

//PRFE Taster SET 
if (PINC & (1<<PINC6) ) 
{
led2_low();
}
else
{
led2_high();//TASTER GEDRCKT
}

//PRFE Taster MOVE
if (PINC & (1<<PINC5) ) 
{
led2_low();
}
else
{
led2_high();//TASTER GEDRCKT
}

}

}






//SPI READ
unsigned char read_SPI(void)
{
while(!(SPSR & (1<<SPIF)));
return (SPDR);
}
//SPI WRITE
unsigned char Write_SPI(char data)
{SPDR=data;
while(!(SPSR & (1<<SPIF)));

return SPDR;
}

//WARTE X MS 
void waitms(unsigned short int ms )
 {
  int i;
  for (i=0;i<ms;i++) _delay_ms(1);
}

void DelayUs(unsigned int N)
{
	unsigned int x;

	for(x=0; x<=N;x++);
}
